com.jnape.palatable.lambda.semigroup.builtin

## Class MinBy<A,B extends Comparable<B>>

- java.lang.Object
- - com.jnape.palatable.lambda.semigroup.builtin.MinBy<A,B>

- Type Parameters:
    `A` - the value type
    `B` - the mapped comparison type
  All Implemented Interfaces:
    Fn1<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,A>>>, Fn2<Fn1<? super A,? extends B>,A,Fn1<A,A>>, Fn3<Fn1<? super A,? extends B>,A,A,A>, SemigroupFactory<Fn1<? super A,? extends B>,A>, Applicative<Fn1<A,Fn1<A,A>>,Fn1<Fn1<? super A,? extends B>,?>>, Cartesian<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,A>>,Fn1<?,?>>, Cocartesian<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,A>>,Fn1<?,?>>, Contravariant<Fn1<? super A,? extends B>,Profunctor<?,Fn1<A,Fn1<A,A>>,Fn1<?,?>>>, Functor<Fn1<A,Fn1<A,A>>,Fn1<Fn1<? super A,? extends B>,?>>, Profunctor<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,A>>,Fn1<?,?>>, Monad<Fn1<A,Fn1<A,A>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadReader<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,A>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadRec<Fn1<A,Fn1<A,A>>,Fn1<Fn1<? super A,? extends B>,?>>, MonadWriter<Fn1<? super A,? extends B>,Fn1<A,Fn1<A,A>>,Fn1<Fn1<? super A,? extends B>,?>>

      public final class MinBy<A,B extends Comparable<B>>
      extends Object
      implements SemigroupFactory<Fn1<? super A,? extends B>,A>

  Given a mapping function from some type `A` to some `Comparable` type `B`, produce a `Semigroup` over `A` that chooses between two values `x` and `y` via the following rules:
  - If `x` is strictly greater than `y` in terms of `B`, return `y`
  - Otherwise, return `x`
  See Also:
    `Min`, `MaxBy`

- - ### Method Summary

    All Methods Static Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `Semigroup<A>` | `checkedApply(Fn1<? super A,? extends B> compareFn)` Invoke this function with the given argument, potentially throwing any `Throwable`.
    `static <A,B extends Comparable<B>> MinBy<A,B>` | `minBy()`
    `static <A,B extends Comparable<B>> Semigroup<A>` | `minBy(Fn1<? super A,? extends B> compareFn)`
    `static <A,B extends Comparable<B>> Fn1<A,A>` | `minBy(Fn1<? super A,? extends B> compareFn, A x)`
    `static <A,B extends Comparable<B>> A` | `minBy(Fn1<? super A,? extends B> compareFn, A x, A y)`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.specialized.SemigroupFactory

      `apply, checkedApply`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn3

      `apply, apply, checkedApply, compose, contraMap, diMapL, discardR, flip, fn3, fn3, fn3, uncurry, widen`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn2

      `curried, curry, fn2, fromBiFunction, toBiFunction`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functions.Fn1

      `andThen, carry, cartesian, censor, choose, cocartesian, diMap, diMapR, discardL, flatMap, fmap, fn1, fromFunction, lazyZip, listens, local, pure, pureFn1, thunk, toFunction, trampolineM, zip, zip`

    - ### Methods inherited from interface com.jnape.palatable.lambda.monad.Monad

      `join`

    - ### Methods inherited from interface com.jnape.palatable.lambda.functor.Functor

      `coerce`

- - ### Method Detail

    - #### checkedApply

          public Semigroup<A> checkedApply(Fn1<? super A,? extends B> compareFn)

      Description copied from interface: `Fn2`
      Invoke this function with the given argument, potentially throwing any `Throwable`.
      Specified by:
        `checkedApply` in interface `Fn1<Fn1<? super A,? extends B extends Comparable<B>>,Fn1<A,Fn1<A,A>>>`
      Specified by:
        `checkedApply` in interface `Fn2<Fn1<? super A,? extends B extends Comparable<B>>,A,Fn1<A,A>>`
      Specified by:
        `checkedApply` in interface `SemigroupFactory<Fn1<? super A,? extends B extends Comparable<B>>,A>`
      Parameters:
        `compareFn` - the argument
      Returns:
        the result of the function application

    - #### minBy

          public static <A,B extends Comparable<B>> MinBy<A,B> minBy()

    - #### minBy

          public static <A,B extends Comparable<B>> Semigroup<A> minBy(Fn1<? super A,? extends B> compareFn)

    - #### minBy

          public static <A,B extends Comparable<B>> Fn1<A,A> minBy(Fn1<? super A,? extends B> compareFn,
                                                                   A x)

    - #### minBy

          public static <A,B extends Comparable<B>> A minBy(Fn1<? super A,? extends B> compareFn,
                                                            A x,
                                                            A y)